Option Explicit

Const sWINDOWS_SECTION_NAME = "windows"
Const sDEVICES_SECTION_NAME = "devices"
Const sDEVICE_KEY_NAME = "device"

Type typWindowsDevice
   sWindowsDeviceUserName As String
   sWindowsDeviceShortName As String
   sWindowsDevicePortName As String
End Type

Sub DUPRT_GetDefaultPrinter (recDefaultPrinter As typWindowsDevice)

'This routine returns the "default" Windows printer.

Dim nStrPos As Integer
Dim sDefaultPrinter As String
Dim nRC As Integer


sDefaultPrinter = sDUINI_GetString(sWINDOWS_SECTION_NAME, sDEVICE_KEY_NAME, "", "")
nStrPos = InStr(sDefaultPrinter, ",")

recDefaultPrinter.sWindowsDeviceUserName = Left$(sDefaultPrinter, nStrPos - 1)

sDefaultPrinter = Mid$(sDefaultPrinter, nStrPos + 1)
nStrPos = InStr(sDefaultPrinter, ",")

recDefaultPrinter.sWindowsDeviceShortName = Left$(sDefaultPrinter, nStrPos - 1)
recDefaultPrinter.sWindowsDevicePortName = Mid$(sDefaultPrinter, nStrPos + 1)

End Sub

Sub DUPRT_GetInstalledPrinters (recInstalledPrinters() As typWindowsDevice)
    
'This routine enumerates the "installed" Windows printers.

Dim nStrPos As Integer, nPrtSub As Integer
Dim sInstalledPrinter As String
ReDim sPrinterNames(0) As String


Call DUINI_GetKeyNames(sDEVICES_SECTION_NAME, sPrinterNames(), "")

ReDim recInstalledPrinters(UBound(sPrinterNames))
    
For nPrtSub = 1 To UBound(sPrinterNames)
   sInstalledPrinter = sDUINI_GetString(sDEVICES_SECTION_NAME, sPrinterNames(nPrtSub), "", "")
   nStrPos = InStr(sInstalledPrinter, ",")

   recInstalledPrinters(nPrtSub).sWindowsDeviceUserName = sPrinterNames(nPrtSub)
   recInstalledPrinters(nPrtSub).sWindowsDeviceShortName = Left$(sInstalledPrinter, nStrPos - 1)

   sInstalledPrinter = Mid$(sInstalledPrinter, nStrPos + 1)
   nStrPos = InStr(sInstalledPrinter, ",")

   If nStrPos > 0 Then
      recInstalledPrinters(nPrtSub).sWindowsDevicePortName = Left$(sInstalledPrinter, nStrPos - 1)
   Else
      recInstalledPrinters(nPrtSub).sWindowsDevicePortName = sInstalledPrinter
   End If
Next

End Sub

Sub DUPRT_SetDefaultPrinter (recDefaultPrinter As typWindowsDevice)
    
'This routine sets the "default" Windows printer to one
'of the "installed" printers.

Dim sNewPrinter As String
Dim nRC As Integer


sNewPrinter = recDefaultPrinter.sWindowsDeviceUserName + "," + recDefaultPrinter.sWindowsDeviceShortName + "," + recDefaultPrinter.sWindowsDevicePortName
    
Call DUINI_WriteString(sWINDOWS_SECTION_NAME, sDEVICE_KEY_NAME, sNewPrinter, "")
Call DUINI_BroadcastWININIChange(sWINDOWS_SECTION_NAME)

End Sub

