VERSION 2.00
Begin Form frmPickDemo 
   Caption         =   "Printer Pick Demo"
   ClientHeight    =   4080
   ClientLeft      =   2655
   ClientTop       =   1455
   ClientWidth     =   3975
   Height          =   4485
   Left            =   2595
   LinkTopic       =   "Form1"
   ScaleHeight     =   4080
   ScaleWidth      =   3975
   Top             =   1110
   Width           =   4095
   Begin CommandButton cmdPrintTest 
      Caption         =   "Print Test"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   2640
      Width           =   3495
   End
   Begin CommandButton cmdSetPrinter 
      Caption         =   "Set Forms Printer (none)"
      Height          =   495
      Index           =   1
      Left            =   240
      TabIndex        =   5
      Top             =   1800
      Width           =   3495
   End
   Begin CommandButton cmdSetPrinter 
      Caption         =   "Set Label Printer (none)"
      Height          =   495
      Index           =   0
      Left            =   240
      TabIndex        =   4
      Top             =   1320
      Width           =   3495
   End
   Begin ListBox lstAvailable 
      Height          =   810
      Left            =   240
      TabIndex        =   0
      Top             =   480
      Width           =   3495
   End
   Begin Label lblStatus 
      Caption         =   "Now printing..."
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   3600
      Width           =   3495
   End
   Begin Label lblAvailable 
      Caption         =   "Available printers:"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   240
      Width           =   3495
   End
End
Option Explicit

'If you have questions, comments, or suggestions for
'improving the code presented here, please forward them
'to me; you're input is welcome:
'
'        Brad Kaenel
'        PC HELP-LINE
'        35250 Silver Leaf Circle
'        Yucaipa, CA  92399
'        United States
'        CIS: 72357,3523
'        Internet: 72357.3523@compuserve.com
'

'The VB Printer object always maps to whichever printer
'the end-user has designated as the "default" Windows
'printer.  There may be situations, however, when an
'application may want to send output to an installed
'printer that is not currently designated as the "default",
'or perhaps to multiple printers simultaneously (or more
'correctly, in sequence, serially).

'While it is not possible to change the behavior of the
'VB Printer object, it is possible to "point" the Printer
'object at will to any desired, installed printer.  This
'can be accomplished, indirectly, by modifying the
'appropriate WIN.INI settings on-the-fly.

'This sample demonstrates how to obtain a list of the
'currently installed printers, and how to modify WIN.INI
'so that any available printer can be "hooked-up" to the
'VB Printer object at runtime.

'Note that this demo always saves the value of the
'default printer before setting it to something else,
'and then restores the original setting when it is
'through.  "Good neighbor" applications should remember
'to "leave things as they found them" when manipulating
'user-defined settings under the covers.

Dim recPrinters() As typWindowsDevice

Dim nPrinterID(2) As Integer
Dim sPrinterTypeName(2) As String

Const nLABELPRINTER = 1
Const nFORMSPRINTER = 2
Const sPRINTERNONE = "(none)"

Sub cmdPrintTest_Click ()

Dim recSaveOrigPrinter As typWindowsDevice


Call DUPRT_GetDefaultPrinter(recSaveOrigPrinter)

If nPrinterID(nLABELPRINTER) > 0 Then
   Call PrintTest(nLABELPRINTER)
End If
If nPrinterID(nFORMSPRINTER) > 0 Then
   Call PrintTest(nFORMSPRINTER)
End If

Call DUPRT_SetDefaultPrinter(recSaveOrigPrinter)

frmPickDemo.lblStatus.Caption = "Printer idle..."

End Sub

Sub cmdSetPrinter_Click (Index As Integer)

Dim sPType As String, sPName As String
Dim sNewCaption As String


If frmPickDemo.lstAvailable.ListIndex < 0 Then
   Exit Sub
End If

sPType = sPrinterTypeName(Index + 1)

If frmPickDemo.lstAvailable.List(frmPickDemo.lstAvailable.ListIndex) = sPRINTERNONE Then
   nPrinterID(Index + 1) = 0
   sPName = sPRINTERNONE
   sNewCaption = "Set " + sPType + " Printer " + sPName
Else
   nPrinterID(Index + 1) = frmPickDemo.lstAvailable.ListIndex
   sPName = recPrinters(frmPickDemo.lstAvailable.ListIndex).sWindowsDeviceUserName
   sNewCaption = sPType + " Printer (" + sPName + ")"
End If

frmPickDemo.cmdSetPrinter(Index).Caption = sNewCaption

End Sub

Sub Form_Load ()
    
Dim nPrinterCount As Integer
ReDim recPrinters(0) As typWindowsDevice


Call DUPRT_GetInstalledPrinters(recPrinters())

For nPrinterCount = 1 To UBound(recPrinters)
   frmPickDemo.lstAvailable.AddItem recPrinters(nPrinterCount).sWindowsDeviceUserName + " on " + recPrinters(nPrinterCount).sWindowsDevicePortName
Next
frmPickDemo.lstAvailable.AddItem sPRINTERNONE, 0

frmPickDemo.lstAvailable.ListIndex = -1
frmPickDemo.lblStatus.Caption = "Printer idle..."

sPrinterTypeName(nLABELPRINTER) = "Label"
sPrinterTypeName(nFORMSPRINTER) = "Forms"

End Sub

Sub PrintTest (ID As Integer)

Dim recTestPrinter As typWindowsDevice


recTestPrinter.sWindowsDeviceUserName = recPrinters(nPrinterID(ID)).sWindowsDeviceUserName
recTestPrinter.sWindowsDeviceShortName = recPrinters(nPrinterID(ID)).sWindowsDeviceShortName
recTestPrinter.sWindowsDevicePortName = recPrinters(nPrinterID(ID)).sWindowsDevicePortName

Call DUPRT_SetDefaultPrinter(recTestPrinter)

frmPickDemo.lblStatus.Caption = "Now printing to " + recPrinters(nPrinterID(ID)).sWindowsDeviceUserName + "..."
frmPickDemo.lblStatus.Refresh

Printer.FontName = "arial"
Printer.FontSize = 24
Printer.FontBold = False
Printer.Print "Goodbye Broadway"
Printer.EndDoc

End Sub

